Index: trunk/compiler/ooasCompiler/.settings/org.eclipse.jdt.core.prefs
===================================================================
--- trunk/compiler/ooasCompiler/.settings/org.eclipse.jdt.core.prefs	(revision 5)
+++ trunk/compiler/ooasCompiler/.settings/org.eclipse.jdt.core.prefs	(revision 6)
@@ -1,11 +1,12 @@
 eclipse.preferences.version=1
 org.eclipse.jdt.core.compiler.codegen.inlineJsrBytecode=enabled
-org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.7
+org.eclipse.jdt.core.compiler.codegen.methodParameters=do not generate
+org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.8
 org.eclipse.jdt.core.compiler.codegen.unusedLocal=preserve
-org.eclipse.jdt.core.compiler.compliance=1.7
+org.eclipse.jdt.core.compiler.compliance=1.8
 org.eclipse.jdt.core.compiler.debug.lineNumber=generate
 org.eclipse.jdt.core.compiler.debug.localVariable=generate
 org.eclipse.jdt.core.compiler.debug.sourceFile=generate
 org.eclipse.jdt.core.compiler.problem.assertIdentifier=error
 org.eclipse.jdt.core.compiler.problem.enumIdentifier=error
-org.eclipse.jdt.core.compiler.source=1.7
+org.eclipse.jdt.core.compiler.source=1.8
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/BoolType.java	(revision 6)
@@ -47,6 +47,11 @@
 	}
 
 	@Override
+	public int valueCount() {
+		return 2;
+	}
+
+	@Override
 	public String AnonymousName()
 	{
 		return "bool";
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/EnumType.java	(revision 6)
@@ -30,7 +30,7 @@
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.Comparator;
-
+
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.TypeIdentifier;
@@ -88,4 +88,10 @@
 		}
 		return result.toString();
 	}
+
+	@Override
+	public int valueCount() {
+		return m_listOfEnumSymbols.size();
+	}
+	
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/IntType.java	(revision 6)
@@ -61,4 +61,10 @@
 			m_low < 0 ? "m" + String.valueOf(m_low * (-1)) : String.valueOf(m_low),
 			m_high);
 	}
+
+	@Override
+	public int valueCount() {
+		return m_high - m_low + 1;
+	}
+
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ListType.java	(revision 6)
@@ -70,4 +70,8 @@
 				m_innerType != null ? m_innerType.toString() : "uninit");
 	}
 
+	@Override
+	public int valueCount() {
+		return (int) Math.pow(m_innerType.valueCount(), m_maxNumberOfElements); // check if this is correct..
+	}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/OoActionSystemType.java	(revision 6)
@@ -156,4 +156,10 @@
 	{
 		m_isInSystemDescription = p;
 	}
+
+	@Override
+	public int valueCount() {
+		return m_objects.size() + m_derivedObjects.size() + 1;
+	}
+	
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TupleType.java	(revision 6)
@@ -28,10 +28,12 @@
 package org.momut.ooas.ast.types;
 
 import java.util.LinkedList;
-
+
 import org.momut.ooas.ast.IAstVisitor;
 import org.momut.ooas.ast.identifiers.TypeIdentifier;
 
+
+
 ///////////////////////////////////////////////
 ///  Complex Type: TupleType
 ///
@@ -71,4 +73,11 @@
 		return result.toString();
 	}
 
+	@Override
+	public int valueCount() {
+		int result = 1;
+		for (final UlyssesType inner: m_innerTypes)
+			result *= inner.valueCount();
+		return result;
+	}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/UlyssesType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/UlyssesType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/UlyssesType.java	(revision 6)
@@ -123,8 +123,13 @@
 		return (m_kind == TypeKind.QrType);
 	}
 
+	/**
+	 * returns the number of unique values of the type (2 for bool, etc..)
+	 */
+	public int valueCount() {
+		throw new NotImplementedException(); // must be overridden by child
+	}
 
-
 	public static String High(UlyssesType atype)
 	{
 		switch (atype.kind())
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ValuedEnumType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ValuedEnumType.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/ValuedEnumType.java	(revision 6)
@@ -77,4 +77,9 @@
 		}
 		return result.toString();
 	}
+
+	@Override
+	public int valueCount() {
+		return m_listOfEnumSymbols.size();
+	}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java	(revision 5)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java	(revision 6)
@@ -28,21 +28,26 @@
 package org.momut.ooas.visitors.analysis;
 
 import java.util.ArrayList;
+import java.util.Collections;
 import java.util.HashSet;
-
-import org.momut.ooas.ast.expressions.CallExpression;
-import org.momut.ooas.ast.identifiers.Identifier;
-import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.MainModule;
-import org.momut.ooas.ast.identifiers.NamedActionIdentifier;
-import org.momut.ooas.ast.identifiers.ParameterIdentifier;
-import org.momut.ooas.ast.statements.Call;
-import org.momut.ooas.ast.types.FunctionType;
-import org.momut.ooas.codegen.prolog.OoaPrologIdentifier;
-import org.momut.ooas.parser.ParserMessage;
-import org.momut.ooas.parser.ParserState;
-import org.momut.ooas.visitors.OoaCompleteAstTraversalVisitor;
 
+import org.momut.ooas.ast.expressions.CallExpression;
+import org.momut.ooas.ast.expressions.Expression;
+import org.momut.ooas.ast.expressions.ExpressionKind;
+import org.momut.ooas.ast.expressions.UnaryOperator;
+import org.momut.ooas.ast.identifiers.Identifier;
+import org.momut.ooas.ast.identifiers.IdentifierKind;
+import org.momut.ooas.ast.identifiers.MainModule;
+import org.momut.ooas.ast.identifiers.NamedActionIdentifier;
+import org.momut.ooas.ast.identifiers.ParameterIdentifier;
+import org.momut.ooas.ast.types.FunctionType;
+import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.codegen.prolog.OoaPrologIdentifier;
+import org.momut.ooas.parser.ParserMessage;
+import org.momut.ooas.parser.ParserState;
+import org.momut.ooas.visitors.OoaCompleteAstTraversalVisitor;
+
+
 public class OoaPrintActionsVisitor extends OoaCompleteAstTraversalVisitor {
 
 	private final ArrayList<String> m_result = new ArrayList<>();
@@ -110,10 +115,14 @@
 		final StringBuilder b = new StringBuilder();
 		b.append("List of controllable/observable actions used:");
 		b.append(System.lineSeparator());
+		Collections.sort(m_result);
+		int i = 0;
 		for (final String s: m_result) {
-			b.append(String.format("\t%s",s));
+			i ++;
+			b.append(String.format("\t%s:\t%s",i,s));
 			b.append(System.lineSeparator());
 		}
+
 		m_ParserState.AddMessage(new ParserMessage("",0,0, b.toString()));
 	}
 
@@ -120,43 +129,67 @@
 	HashSet<String> m_seenActions = new HashSet<String>();
 
 	@Override
-	public void visit(Call call) {
-		final CallExpression e = (CallExpression) call.callExpression();
-//		for (final FunctionIdentifier id : call.callExpression().callTargets()) {
-			final FunctionType actionType = (FunctionType) e.child().type();
-			String ctrObs = "";
-			switch(actionType.functionType()) {
-				default:
-					// something we do not know...
-					throw new UnsupportedOperationException();
-				case Continuous:
-					// we do not support continuous actions here
-					throw new UnsupportedOperationException();
-				case Internal:
-				case Method:
-					// we do not print methods or internal actions
-					//continue;
-					return;
-				case Observable:
-					// yes, report it
-					ctrObs = "obs";
-					break;
-				case Controllable:
-					// yes, report it
-					ctrObs = "ctr";
-					break;
-			}
-			final OoaPrologIdentifier pIdent = m_idFactory.create();
-			e.child().Accept(pIdent);
+	public void visit(CallExpression e)
+	{
+		final FunctionType actionType = (FunctionType) e.child().type();
+		String ctrObs = "";
+		switch(actionType.functionType()) {
+			default:
+				// something we do not know...
+				throw new UnsupportedOperationException();
+			case Continuous:
+				// we do not support continuous actions here
+				throw new UnsupportedOperationException();
+			case Internal:
+			case Method:
+				// we do not print methods or internal actions
+				//continue;
+				return;
+			case Observable:
+				// yes, report it
+				ctrObs = "obs";
+				break;
+			case Controllable:
+				// yes, report it
+				ctrObs = "ctr";
+				break;
+		}
+		final OoaPrologIdentifier pIdent = m_idFactory.create();
+		e.child().Accept(pIdent);
 
-			final String actionString = String.format("%s %s", ctrObs, pIdent.toString().replaceAll("'", ""));
-			if (!m_seenActions.contains(actionString)) {
-				m_seenActions.add(actionString);
-				m_result.add(actionString);
+		final StringBuilder parameter = new StringBuilder();
+		if (e.arguments().size() > 0) {
+			int z = 0;
+			for (final UlyssesType ut: actionType.parameter()) {
+				if (e.arguments().size() <= z)
+					continue;
+				Expression arg = e.arguments().get(z);
+				while (arg.kind() == ExpressionKind.Cast)
+					arg = ((UnaryOperator)arg).child();
+
+				if (z != 0) {
+					parameter.append(", ");
+				} else
+					z++;
+				parameter.append(ut.toString());
+				parameter.append(" #: ");
+				parameter.append( Integer.toString(ut.valueCount()) );
+				parameter.append(" [call-type: ");
+				parameter.append(arg.type().toString());
+				parameter.append(" #: ");
+				parameter.append( Integer.toString(arg.type().valueCount()) );
+				parameter.append("]");
 			}
-//		}
-	}
+		}
 
+		final String actionString = String.format("%s %s(%s)", ctrObs, pIdent.toString().replaceAll("'", ""), parameter.toString());
+		if (!m_seenActions.contains(actionString)) {
+			m_seenActions.add(actionString);
+			m_result.add(actionString);
+		}
+	};
+
+
 	@Override
 	public String toString() {
 		return m_result.toString();
Index: trunk/compiler/ooasCompiler/.classpath
===================================================================
--- trunk/compiler/ooasCompiler/.classpath	(revision 5)
+++ trunk/compiler/ooasCompiler/.classpath	(revision 6)
@@ -1,11 +1,11 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<classpath>
-	<classpathentry kind="src" path="src"/>
-	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
-	<classpathentry kind="lib" path="libraries/antlr-3.4-complete.jar"/>
-	<classpathentry kind="lib" path="libraries/protobuf.jar"/>
-	<classpathentry kind="lib" path="libraries/jna-4.0.0.jar"/>
-	<classpathentry kind="lib" path="libraries/jna-platform-4.0.0.jar"/>
-	<classpathentry kind="lib" path="libraries/ecj-4.4.2.jar"/>
-	<classpathentry kind="output" path="bin"/>
-</classpath>
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="lib" path="libraries/antlr-3.4-complete.jar"/>
+	<classpathentry kind="lib" path="libraries/protobuf.jar"/>
+	<classpathentry kind="lib" path="libraries/jna-4.0.0.jar"/>
+	<classpathentry kind="lib" path="libraries/jna-platform-4.0.0.jar"/>
+	<classpathentry kind="lib" path="libraries/ecj-4.5.jar"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
